/*
* teetime
* reinhard@finalmedia.de
* Mo 31. Aug 18:53:55 CEST 2020
*
* clone stdin to stdout and terminate process
* after n seconds, if there is no further input
* on stdin
*
* usage:  ... | teetime 2s | ...
*
*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>

unsigned short stalled=0;
unsigned int seconds=0;


void sig_handler(int sig) {
if (stalled==1) {
	if (getenv("DEBUG")) write(2,"teetime. killing now...\n",24);
	kill(getpid(),SIGCONT);
	kill(getppid(),SIGCONT);
	sleep(1);
	kill(getpid(),SIGKILL);
	kill(getppid(),SIGKILL);
	exit(0);
}
stalled=1;
alarm(seconds);
}

int main(int argc,const char *const *argv,const char *const *envp)
{

unsigned char c;

if (argc<2) { write(2,"usage: teetime seconds\n",23); return 1; }

seconds = (unsigned int) atoi(*++argv);
if (seconds<1) return 1;

signal(SIGALRM,sig_handler);
sig_handler(SIGALRM);
alarm(seconds);

while ((c=getc(stdin)) != EOF) {
	putc(c,stdout);
	stalled=0;
}

return 0;

}

